/* $Id: civmap.h,v 1.1 1998/04/25 10:25:31 bj Exp $
 *
 * By Ben Jackson <ben@ben.com>.
 */

#define CIVMAGIC	"CIVILIZE"

typedef enum { T_Desert, T_Prairie, T_Grasslands, T_Forest, T_Hills,
	T_Mountains, T_Tundra, T_Arctic, T_Swamp, T_Jungle, T_Ocean } land_t;

#define TM_River 0x80

typedef struct _CivmapBlock {
	unsigned char	type:4;
	unsigned char	dunno1:3;	/* always zero? */
	unsigned char	hasRiver:1;

	unsigned char	hasUnit:1;
	unsigned char	hasCity:1;
	unsigned char	hasIrrigation:1;
	unsigned char	hasMining:1;
	unsigned char	hasRoad:1;
	unsigned char	hasRailroad:1;
	unsigned char	hasFortress:1;
	unsigned char	hasPollutionMaybe:1;

	unsigned char	dunno3, dunno4, dunno5;
	unsigned char	dunno6;
} CivmapBlock;

typedef struct _CivmapCity {
	unsigned short	x, y;
	unsigned short	dunno3[2];
	unsigned char	tribe, pop;
	unsigned short	dunno1[6];
	unsigned short	cur_prod;
	unsigned short	dunno4[4];
	char		name[16];
	unsigned short	dunno2[15];
	unsigned char	trade, hmmm, food, production, hmmmmm, hmm;
} CivmapCity;

typedef struct _CivmapUnit {
	unsigned short	x, y;
	unsigned char	zero;
	unsigned char	isFortified:1;
	unsigned char	hmm0:4;
	unsigned char	isVeteran:1;
	unsigned char	hmm1:2;
	unsigned char	type;
	unsigned char	tribe;	/* zero == barbarians */
	unsigned char	zero2;
	unsigned char	dunno2;
	unsigned short	dunno3[8];
} CivmapUnit;

typedef struct _CivmapCivStart {
	unsigned char	x, y;
} CivmapCivStart;

typedef struct _Civmap {
	CivmapBlock	**data;
	unsigned char	xsize, ysize;
	short		nunits;
	CivmapUnit	*units;
	short		ncities;
	CivmapCity	*cities;
	short		year;
	short		turn;
	short		level;
	CivmapCivStart	civs[21];
} Civmap;

#define UNIT_DIPLOMAT	46

Civmap *readCivmap(FILE *);

#define GIFBLOCK_YSIZE	32
#define GIFBLOCK_XSIZE	64

#define COASTBLOCK_YSIZE	16
#define COASTBLOCK_XSIZE	32

#define MAX_TRIBES	8
